<?php

/**
 * @file
 * Setup GA default variables.
 * 
 * @todo: Look for better implementation in order to make easy for other modules
 * to manipulate the GA settings.
 */

/**
 * Setup GA numeric fields information variable.
 *
 * @param $type
 *  An string contains the machine name of a content type 
 * 
 * @return
 *   An array containing a set of settings variables.
 */
function gallery_assist_default_settings($type = 'default') {

  switch ($type) {
    case 'numeric_form_fields':
      $variables = array(
        'thm_margin' => array(
          'size' => 20,
          'name' => 'Margin'
        ),
        'thm_padding' => array(
          'size' => 20,
          'name' => 'Padding'
        ),
        'thm_border' => array(
          'size' => 20,
          'name' => 'Border'
        ),
        'border_radius' => array(
          'size' => 20,
          'name' => 'Radius'
        ),
        'shadow_size' => array(
          'size' => 20,
          'name' => 'Shadow size'
        )
      );
      break;
    case 'default':
      $variables = _gallery_assist_default_settings($type = 'default');
      break;
  }

  return $variables;
}

/**
 * Setup GA default variables.
 *
 * @param $type
 *  An string contains the machine name of a content type 
 * 
 * @return
 *   An array containing a set of settings variables.
 */
function _gallery_assist_default_settings($type = 'default') {
  $variables = array(
    'teaser_items_per_row' => '3',
    'teaser_rows_per_page' => '1',
    'teaser_container_align' => 'center',
    'teaser_container_float' => 'none',
    'teaser_hide_container' => '',
    'page_items_per_row' => '3',
    'page_rows_per_page' => '3',
    'page_container_align' => 'center',
    'page_container_float' => 'none',
    'page_hide_container' => '',
    'page_pager_enable' => '',
    'page_pager_quantity' => 5,
    'icon_image_style' => 'gallery_default_icon_75',
    'thm_margin' => '10',
    'thm_padding' => '20',
    'thm_border' => '10',
    'thm_border_color' => '#0074BD',
    'thm_border_color_hover' => '#23AEFF',
    'thm_linked_to' => 'preview',
    'thm_link_type' => 'default',
    'thumbnail_image_style' => 'gallery_default_thumbnail_100',
    'preview_image_style' => 'gallery_default_preview_550',
    'preview_container_align' => 'center',
    'preview_container_float' => 'none',
    'display_download_link' => '',
    'upload_resolution' => '0',
    'upload_extensions' => 'jpg jpeg gif png zip',
    'upload_file_size' => '0',
    'upload_user_size' => '0',
    'pager_type' => 'numeric',
    'pager_theme' => 'default',
    'pager_position' => 'top',
    'pager_align' => 'center',
    'pager_format' => 'full',
    'pager_quantity' => '5',
    'pager_thm_height' => '20',
    'pager_thm_active_height' => '25',
    'image_style' => 'none',
    'db_order_field' => 'weight',
    'db_order_direction' => 'ASC',
    'display_option' => 'grid',
    'ga_shadow' => '0',
    'border_radius' => '19',
    'shadow_size' => '6',
  );

  return $variables;
}

/**
 * Setup GA allow variables.
 * 
 * @return
 *   An array containing a set of settings variables.
 */
function gallery_assist_settings_allowed() {
  $allowed = array(
    'teaser_container_align_allowed' => TRUE,
    'teaser_container_float_allowed' => TRUE,
    'page_container_align_allowed' => TRUE,
    'page_container_float_allowed' => TRUE,
    'display_download_link_allowed' => TRUE,
    'db_order_field_allowed' => TRUE,
    'db_order_direction_allowed' => TRUE,
    'thm_linked_to_allowed' => TRUE,
    'thm_link_type_allowed' => TRUE,
    'display_option_allowed' => TRUE,
    'ga_shadow_allowed' => TRUE,
  );

  variable_set("gallery_assist_default_allowed", $allowed);
  variable_set("gallery_assist_gallery_assist_allowed", $allowed);
}
